import QUB
from Buttons import *
from qubtree import Node

### -------------------------------------------------------------------------
### Find pulses as transition below PulseLevel followed by transition above pulse level
### then add a list segment for each pulse 
def Phil(props):
    nPulseLevel = props['PulseLevel']
    iLeadPts = props['LeadingPoints']

    aPulse = []                 ## list of pulses discovered 

    ### Select the data 
    alldata = QUB.DataView.currData
    dataDef = QUB.getChosenData()
    segDef = dataDef.find('DataSet').find('Segment')

    ### scan the data for pulses, add to list 
    iPulse=0
    iTtl=0
    while not segDef.isNull :
        QUB.fillData(segDef)
        chanDef = segDef.find('Channel')
        iPointsDef = chanDef.data.count

        iStart=-1
        iFound=0
        for iPoint in range(iPointsDef):
            iData = chanDef.data[iPoint]
            if iStart==-1 : 
                if (iData<nPulseLevel) : 
                    iStart = iPoint
            else :
                if (iData>nPulseLevel) :
                    if iFound==1 :
                        del aPulse[len(aPulse)-1][1]
                        aPulse[len(aPulse)-1].insert(1,iTtl+iStart-iLeadPts*2)
                    aPulse.append( [ iTtl + max(0,iStart-iLeadPts), iTtl+iPoint, str(iPulse) ] )
                    QUB.Report( 'Found '+str(iStart)+str(iPoint+iTtl) )
                    iStart=-1
                    iPulse = iPulse + 1
                    iFound=1
                                
        iTtl = iTtl + iPointsDef
        if iFound==1 : 
            del aPulse[len(aPulse)-1][1]
            aPulse[len(aPulse)-1].insert(1,iTtl+iPointsDef-1)
            
        segDef = segDef.next('Segment')

    ### Create selection list
    for i in range( len(aPulse) ) :
        aPulse[i]=tuple(aPulse[i])
    alldata.setList('Pulse', aPulse )

    ### Unload the Data ###
    segDef.remove(chanDef)

AddTaskButton( 'Phil', # button text
               Phil,   # function
               'Phil',       # short text for small buttons
               0,            # show settings dialog on left-click?
               1,            # show settings dialog on right-click?
               "Select pulse sections",   # tool-tip
               "Select pulse sections",   # description in "Edit Buttons"
               "Select pulse sections:",  # caption for the settings dialog
               [TextField("PulseLevel", "Pulse when < :", "0.5", acceptFloat ),
                TextField("LeadingPoints", "Leading Points:", "2000", acceptIntGreaterThan(-1))],
               'Lists' )

